import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.util.*;

public class WM_Lake extends Applet implements Runnable
 {
  // Variabili relative all'applet
  String VER="1.03";
  int _fi=0;
  Image IMG,FG_IMG,IMG2;
  int INT_IMG[];
  Dimension apDIM;
  int apDX,apDY; 
  //String REGCODE;
  String TARGET;    
  int FG_X,FG_Y,TEXTPOS,BTXTPOS,TEXTF,wDX,wDY,WH,NOISE,LSPEED,WPAL,LMOUSE,MOV,LMOV;
  double STEP;
  int NUM,TEXTH,DIR,TEXTV,WAIT,TYPE;
  Color TEXTCOL,BTEXTCOL,COL;
  String TEXT=null,BTEXT=null,URL=null,NOMI_PICS=null;  
  int SX,RX,RY,RZ;
  Font f1 = new Font("TimesRoman",Font.PLAIN,12);
  Font f2;

  // Variabili per il thread e temporizzazione
  Thread RUN;
  long TIME,TFPS;
  int FPS,PFPS;

  // Variabili per il doppio buffer
  Image VSCREEN;   
  Graphics GVSCREEN;

  // Look Up Table
  double LUTC[]=new double[360]; // LUT del coseno
  double LUTS[]=new double[360]; // LUT del seno
  int LUTWT[]=new int[720];      // LUT dell'effetto acqua
  
  // Variabili per l'effetto lake
  int dFX,dFY;
  int XS=1,YS=1,DXS=1,DYS=1; // Surfing
  int XPOS,YPOS;
  boolean black;
  int INT_WMAP[]; // Mappa Water 0=corrente 1=nuova (inizialmente)
  int NUO=1,CUR=0;

  public void init()
   {
    // Carica lo sfondo e i parametri
    int i=0,aux;
    // Inizializza applet
    // setSize(320,200);
    apDIM=getSize();
    apDX=apDIM.width;         
    apDY=apDIM.height;    
    try 
     {
      // Inizializza le immagini	
      MediaTracker tr=new MediaTracker(this);
      PixelGrabber pg;
      // Codice di registrazione
      //REGCODE =getParameter("regcode");
      // Parametri applet                       
      IMG     =getImage(getDocumentBase(),getParameter("bgimg")); // Carica tutte le immagini      
      FG_IMG  =getImage(getDocumentBase(),getParameter("fgimg"));
      FG_X    =Integer.parseInt(getParameter("fgimgx"));
      FG_Y    =Integer.parseInt(getParameter("fgimgy"));      
      WH      =Integer.parseInt(getParameter("lakeheight"));
      LSPEED  =Integer.parseInt(getParameter("lakesp"));
      STEP=(double)LSPEED/100;
      NOISE   =Integer.parseInt(getParameter("lakenoise"));
      LMOUSE  =Integer.parseInt(getParameter("lakemouse"));
      WPAL    =Integer.parseInt(getParameter("lakepalette"));
      LMOV    =Integer.parseInt(getParameter("lakemove"));
      if(LMOV==0) MOV=0;
      // Parametri generali
      TEXT    =getParameter("scrolltext");
      TEXTH   =Integer.parseInt(getParameter("scrolltexth"));
      if(TEXTH<=4) TEXTH=36;
      DIR     =Integer.parseInt(getParameter("scrolltextdir"));
      TEXTV   =Integer.parseInt(getParameter("scrolltextsp"));
      TEXTPOS =Integer.parseInt(getParameter("scrolltextpos"));
      TEXTCOL =new Color(Integer.parseInt(getParameter("scrolltextcol"),16));
      TEXTF   =Integer.parseInt(getParameter("scrolltextfont"));
      BTEXT   =getParameter("bottomtext");
      BTEXTCOL=new Color(Integer.parseInt(getParameter("bottomtextcol"),16));
      BTXTPOS =Integer.parseInt(getParameter("bottomtextalign"));
      URL     =getParameter("urltolink");
      TARGET  =getParameter("urltarget");      
      tr.addImage(IMG,0);
      tr.waitForID(0);      
      // Inizializza Lake
      /*INT_IMG=new int[apDX*apDY];
      INT_WMAP=new int[apDX*WH];
      pg=new PixelGrabber(IMG,0,0,apDX,apDY,INT_IMG,0,apDX);
      pg.grabPixels();
      for(int x=0;x<apDX;x++) // prendo la parte superiore dell'immagine
       {
        for(int y=0;y<WH;y++)
         {
          INT_WMAP[x+y*apDX]=INT_IMG[x+y*apDX];
         }
       }      
      IMG2=createImage(new MemoryImageSource(apDX,WH,INT_WMAP,0,apDX));
      */
      //IMG2=IMG2.getScaledInstance(apDX,apDY-WH,Image.SCALE_DEFAULT);
      wDX=apDX;
      wDY=apDY;//(apDY-WH);
      INT_IMG=new int[wDX*wDY];
      INT_WMAP=new int[wDX*wDY]; // Mappa
      IMG2=IMG;      
      pg=new PixelGrabber(IMG2,0,0,wDX,wDY,INT_IMG,0,wDX);      
      pg.grabPixels();
      int c1,r1,g1,b1,c2,r2,g2,b2;
      for(int x=0;x<wDX;x++)
       {
        for(int y=0;y<wDY/2;y++)
         {
          c1=INT_IMG[x+(wDY-1-y)*wDX]; // Scambia i colori (capovolge l'immagine)
          r1=(c1>>16) & 0xff;
          g1=(c1>>8)  & 0xff;
          b1=c1       & 0xff;
          c2=INT_IMG[x+y*wDX];
          r2=(c2>>16) & 0xff;
          g2=(c2>>8)  & 0xff;
          b2=c2       & 0xff;
          if(WPAL==0)
           {
            // Naturale
            c1=(255<<24)|(r1<<16)|(g1<<8)|b1;
            c2=(255<<24)|(r2<<16)|(g2<<8)|b2;
           }
          if(WPAL==1)
           {
            // Blu
            c1=(255<<24)|(0<<16)|(0<<8)|b1;
            c2=(255<<24)|(0<<16)|(0<<8)|b2;
           }
          if(WPAL==2)
           {
            // Azzurra
            c1=(255<<24)|(0<<16)|(g1<<8)|b1;
            c2=(255<<24)|(0<<16)|(g2<<8)|b2;
           }
          if(WPAL==3)
           {
            // Red
            c1=(255<<24)|(r1<<16)|(0<<8)|0;
            c2=(255<<24)|(r2<<16)|(0<<8)|0;
           }
          if(WPAL==4)
           {
            // Giallo
            c1=(255<<24)|(r1<<16)|(g1<<8)|0;
            c2=(255<<24)|(r2<<16)|(g2<<8)|0;
           }
          if(WPAL==5)
           {
            // B/W
            c1=(r1+g1+b1)/3;
            c2=(r2+g2+b2)/3;
            c1=(255<<24)|(c1<<16)|(c1<<8)|c1;
            c2=(255<<24)|(c2<<16)|(c2<<8)|c2;
           }
          INT_IMG[x+y*wDX]=c1;
          INT_IMG[x+(wDY-1-y)*wDX]=c2;
         }
       }
      tr.addImage(FG_IMG,1);
      tr.waitForID(1);      
     } catch(InterruptedException e) {};
     
    /*if(REGCODE.length()>=10)
     {
      if(getDocumentBase().toString().toUpperCase().startsWith("HTTP://"))
       {
        if(getDocumentBase().toString().substring(7).toUpperCase().indexOf(AR_util.AR_verify(REGCODE))!=-1) _fi=0;
       } 
      else 
       {
        if(getDocumentBase().toString().toUpperCase().indexOf(AR_util.AR_verify(REGCODE))!=-1) _fi=0;
       }
      if(AR_util.AR_verify(REGCODE).equals("")) _fi=1;
     } 
    else _fi=1;*/
    if(_fi==1)
     {
      if(TEXTV<=0) TEXTV=1;
      if(TEXTH<=24) TEXTH=36;
     }    
    if(TEXTF==0) f2=new Font("TimesRoman",Font.BOLD,TEXTH);
    if(TEXTF==1) f2=new Font("Arial",Font.BOLD,TEXTH);
    if(TEXTF==2) f2=new Font("Courier",Font.BOLD,TEXTH);
    if(_fi==1) TEXT="http://www.valarsoft.com";
    if(DIR==1) SX=-getFontMetrics(f2).stringWidth(TEXT); else SX=apDX;
    if(_fi==1) TEXTPOS=apDY>>1;

    // Inizializza il doppio buffer
    VSCREEN=createImage(apDX,apDY);
    GVSCREEN=VSCREEN.getGraphics();

    // Inizializza le LUT
    AR_setLUT();    
   }

  public void start()
   {
    RUN=new Thread(this);
    RUN.setPriority(RUN.MIN_PRIORITY);
    RUN.start();
   }

  public void run()
   {
    double ANG=0;    
    int tmp,attesa=1;
    double frax=0;
    long tdif,ti=System.currentTimeMillis();
    getGraphics().drawString("Loading...",1,apDY-4);
    while(true)
     {      
      // Corpo del programma
     
      //AR_clear(GVSCREEN,Color.green);
      GVSCREEN.drawImage(IMG,0,-WH,null);
      GVSCREEN.setColor(BTEXTCOL);

      AR_wavemap(ANG);             // Calcola nuova watermap 
      ANG=ANG+STEP; if(ANG>360) ANG=0;
      if(LMOV==1)
       {
        MOV=(int)ANG%4;
        if(MOV==3) MOV=1;
       }
      AR_lake(frax,GVSCREEN); // A video

      System.gc();
      if(_fi==1) GVSCREEN.drawString("Webmatic Lake "+VER+" (demo)",1,apDY-4);
      else
       {       	
       	if(BTXTPOS==0) GVSCREEN.drawString(BTEXT,1,apDY-4); // Left
       	if(BTXTPOS==1) GVSCREEN.drawString(BTEXT,(apDX-getFontMetrics(f1).stringWidth(BTEXT))/2,apDY-4); // Center
       	if(BTXTPOS==2) GVSCREEN.drawString(BTEXT,apDX-getFontMetrics(f1).stringWidth(BTEXT),apDY-4); // Right
       }
      GVSCREEN.drawImage(FG_IMG,FG_X,FG_Y,null); // Immagine in primo piano (logo)             
      GVSCREEN.setFont(f2);
      GVSCREEN.setColor(TEXTCOL);
      GVSCREEN.drawString(TEXT,SX,TEXTPOS);
      GVSCREEN.setColor(BTEXTCOL);
      if(DIR==1) 
       {
        SX+=TEXTV;
        if(SX>=apDX) SX=-getFontMetrics(f2).stringWidth(TEXT);
       }
      else
       {
        SX-=TEXTV;
        if(SX<=-getFontMetrics(f2).stringWidth(TEXT)) SX=apDX;
       }
      GVSCREEN.setFont(f1);
      AR_waitfps(60);           // Sincronizza i frame per secondo
      paint(getGraphics());     // Manda a video
      try
       {
        RUN.yield();
       } catch(Exception e) {};   
     }
   }

  public void stop()
   {
    RUN.stop();
   }

  public String getAppletInfo()
   {
    return "Webmatic Lake "+VER+" by Amuso Raffaele - http://www.valarsoft.com";
   }

  public final boolean mouseUp(Event e, int x, int y)
   {
    try
     {          
      URL link;
      if(_fi==0)
       {
        link=new URL(getCodeBase(),URL);
        if(URL.compareTo("")!=0) getAppletContext().showDocument(link,TARGET);
       } 
      else
       {
        link=new URL(getCodeBase(),"http://www.valarsoft.com");
        getAppletContext().showDocument(link,"_blank");
       }
     } catch(MalformedURLException ex) {};
    return true;
   }

  public final boolean mouseMove(Event e, int x, int y)
   {
    if(LMOUSE==1)
     {
      WH=apDY-y;
      if(WH<0) WH=0;
      if(WH>apDY-1) WH=apDY-1;
     }
    return true;
   }

  public void paint(Graphics g)
   {
    g.drawImage(VSCREEN,0,0,null); // Stampa il buffer nel video (potrei stampare piu' di un buffer, basta duplicare la linea e riferirsi ad un altro buffer buf)
   }

  // ================= LIBRERIA =======================================================

  public synchronized final void AR_waitfps(int maxfps) // Sincronizza i frame per secondo
   {
    long ms=1000/maxfps;
    long mdif=System.currentTimeMillis()-TIME;

    if(mdif<ms)
     {
      try 
       { 
        RUN.sleep(ms-mdif); 
       } catch (InterruptedException e) {};
     }
    // Stampa fps
    TFPS+=System.currentTimeMillis()-TIME;
    FPS++;
    if(TFPS>=1000) { TFPS=0; PFPS=FPS; FPS=0; }
    if(_fi==1) GVSCREEN.drawString("fps: "+String.valueOf(PFPS),apDX-getFontMetrics(f1).stringWidth("fps: "+String.valueOf(PFPS)),11);
    // Coglie l'attimo
    TIME=System.currentTimeMillis();
   }

  public void AR_setLUT() // Prepara le LUT del seno e del coseno
   {
    int i; 
 
    for(i=0;i<360;i++)
     {
      LUTC[i]=Math.cos(AR_util.AR_rad(i));
      LUTS[i]=Math.sin(AR_util.AR_rad(i));
     }
    for(i=-360;i<360;i++)
     {
      LUTWT[i+360]=(int)((Math.tan(Math.asin((Math.sin(Math.atan(i))/4)))*i));
     }     
   }

  public void AR_clear(Graphics g, Color c)
   {
    g.setColor(c);
    g.fillRect(0,0,apDX,apDY);
   }

  public void AR_putpx(Graphics g, int x, int y, Color c)
   {
    // Disegna un pixel
    g.setColor(c);
    g.drawLine(x,y,x,y);
   }

  public void AR_line(int px, int py, int cx, int cy, int cz, int rx, int ry, int rz, Color Col, int Xa, int Ya, int Za, int Xb, int Yb, int Zb, int zo, Graphics g)
   {
    // Stampa una linea con
    // px,py posizione sullo schermo
    // cx,cy,cz traslazione nello spazio
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // zo fattore di zoom
    // Col colore delle stelle
    // g schermo dove stampare il tutto
    int x1,y1,z1,x2,y2,z2;                            // Punti da unire con una linea
    double xa,ya,za,xb,yb,zb,xa1,ya1,za1,xb1,yb1,zb1; // Variabili per i calcoli
    double ta,tb;                                     // Variabili per la prospettiva
    int d=128;                                        // Distanza dall'occhio

    x1=Xa*zo+cx; y1=Ya*zo+cy; z1=Za*zo+cz;
    x2=Xb*zo+cx; y2=Yb*zo+cy; z2=Zb*zo+cz;
    // Rotazione lungo asse X
    ya1=y1*LUTC[rx]+z1*LUTS[rx];
    za1=y1*LUTS[rx]-z1*LUTC[rx];
    yb1=y2*LUTC[rx]+z2*LUTS[rx];
    zb1=y2*LUTS[rx]-z2*LUTC[rx];
    // Rotazione lungo asse Y
    xa1=x1*LUTC[ry]+za1*LUTS[ry];
    za=x1*LUTS[ry]-za1*LUTC[ry];
    xb1=x2*LUTC[ry]+zb1*LUTS[ry];
    zb=x2*LUTS[ry]-zb1*LUTC[ry];
    // Rotazione lungo asse Z
    xa=xa1*LUTC[rz]+ya1*LUTS[rz];
    ya=xa1*LUTS[rz]-ya1*LUTC[rz];
    xb=xb1*LUTC[rz]+yb1*LUTS[rz];
    yb=xb1*LUTS[rz]-yb1*LUTC[rz];
    // Proiezione prospettica
    ta=za+d;
    tb=zb+d;
    x1=(int)(d*xa/ta);
    y1=(int)(d*ya/ta);
    x2=(int)(d*xb/tb);
    y2=(int)(d*yb/tb);
    g.setColor(Col);
    g.drawLine(x1+px,y1+py,x2+px,y2+py);   
   }

  public void AR_wire_poly(int px, int py, int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_poly poly, int zo, Graphics g)
   {
    for(int i=0;i<poly.nlines-1;i++)
     {
      AR_line(px,py,cx,cy,cz,rx,ry,rz,Col,poly.punto[i].x,poly.punto[i].y,poly.punto[i].z,poly.punto[i+1].x,poly.punto[i+1].y,poly.punto[i+1].z,zo,g);
     }
   }

  public void AR_fill_poly(int px, int py, int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_poly poly, int zo, Graphics g)
   {
    // Stampa una linea con
    // px,py posizione sullo schermo
    // cx,cy,cz traslazione nello spazio
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // zo fattore di zoom
    // Col colore delle stelle
    // g schermo dove stampare il tutto
    int X[] = new int[poly.nlines];                   // Punti che formeranno il poligono
    int Y[] = new int[poly.nlines];
    int x1,y1,z1;                                     // Punti da unire con una linea
    double xa,ya,za,xb,yb,zb,xa1,ya1,za1,xb1,yb1,zb1; // Variabili per i calcoli
    double ta;                                        // Variabili per la prospettiva
    int d=128;                                        // Distanza dall'occhio

    for(int i=0;i<poly.nlines;i++)
     {
      x1=poly.punto[i].x*zo+cx; y1=poly.punto[i].y*zo+cy; z1=poly.punto[i].z*zo+cz;
      // Rotazione lungo asse X
      ya1=y1*LUTC[rx]+z1*LUTS[rx];
      za1=y1*LUTS[rx]-z1*LUTC[rx];
      // Rotazione lungo asse Y
      xa1=x1*LUTC[ry]+za1*LUTS[ry];
      za=x1*LUTS[ry]-za1*LUTC[ry];
      // Rotazione lungo asse Z
      xa=xa1*LUTC[rz]+ya1*LUTS[rz];
      ya=xa1*LUTS[rz]-ya1*LUTC[rz];
      // Proiezione prospettica
      ta=za+d;
      X[i]=(int)(d*xa/ta)+px;
      Y[i]=(int)(d*ya/ta)+py;
     }
    g.setColor(Col);
    g.fillPolygon(X,Y,poly.nlines-1);
   }

  public AR_stars AR_stars(int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_stars sp, Graphics g)
   {
    // Simula un campo stellare con
    // cx,cy centro di espansione
    // cz distanza del centro di espansione
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // Col colore delle stelle
    // sp struttura di tipo AR_stars contenente i dati per le stelle
    // g schermo dove stampare il tutto
    int x,y,x1,y1,z1;            // Punto da disegnare
    double xa,ya,za,xa1,ya1,za1; // Variabili per i calcoli
    double t;                    // Variabile per la prospettiva
    int d=128,dis;               // Distanza dall'occhio

    for(int i=0;i<sp.nstars-1;i++) // Per ogni stella
     {
      x1=sp.star[i].x;
      y1=sp.star[i].y;
      z1=sp.star[i].z+cz;
      // Rotazione lungo asse X
      ya1=y1*LUTC[rx]+z1*LUTS[rx];
      za1=y1*LUTS[rx]-z1*LUTC[rx];
      // Rotazione lungo asse Y
      xa1=x1*LUTC[ry]+za1*LUTS[ry];
      za=x1*LUTS[ry]-za1*LUTC[ry];
      // Rotazione lungo asse Z
      xa=xa1*LUTC[rz]+ya1*LUTS[rz];
      ya=xa1*LUTS[rz]-ya1*LUTC[rz];
      // Proiezione prospettica
      t=za+d;
      if(t==0) t=1; // Evita la divisione per 0
      x1=(int)(d*xa/t); y1=(int)(d*ya/t);
      x=x1+cx; y=y1+cy;
      sp.star[i].z--; // Fa "avanzare" le stelle
      // Controlli
      if(x>apDX || x<0 || y>apDY || y<0 || z1<-200)
       {
        sp.star[i].x=AR_util.AR_rand(apDX)-(apDX>>1);
        if(sp.star[i].x==0) sp.star[i].x=1;
        sp.star[i].y=AR_util.AR_rand(apDY)-(apDY>>1);
        sp.star[i].z=AR_util.AR_rand(400)-200;
       }
      dis=-sp.star[i].z>>7;
      if(dis==0) dis=1;
      g.setColor(Col);
      g.fillOval(x,y,dis,dis);   
     }
    return sp;
   }

  public AR_drops AR_rain(int spe, int vel, Color Col, AR_drops dr, Graphics g)
   {
    // Simula la pioggia con
    // spe spessore delle gocce
    // Col colore delle gocce
    // sp struttura di tipo AR_drops contenente i dati per le gocce
    // g schermo dove stampare il tutto
    int x,y; // Variabili per la stampa di una goccia

    for(int i=0;i<dr.ndrops-1;i++) // Per ogni stella
     {
      x=dr.drop[i].x;
      y=dr.drop[i].y;
      dr.drop[i].y+=vel; // Fa "cadere" la pioggia
      // Controlli
      if(x>apDX || x<0 || y>apDY || y<0)
       {
        dr.drop[i].x=AR_util.AR_rand(apDX);
        dr.drop[i].y=AR_util.AR_rand(apDY)-apDY;
       }
      g.setColor(Col);
      g.fillRect(x,y,spe,spe+1);   
     }
    return dr;
   }

  public void AR_wavemap(double ang)
   {
    // Crea la wave map    
    int x,y,a;
    double dy;
           
    for(x=1;x<wDX-1;x++)	
     {
      for(y=1;y<wDY;y++)
       {
       	dy=y;       	
       	if(NOISE==1)
       	 {
       	  // con rumore
       	  a=(int)((28*Math.sin(ang+(500/dy))));
       	  INT_WMAP[x+y*wDX]=a*(y>>3);
       	 }
       	else
       	 {
       	  // senza rumore
       	  a=(int)((28*Math.sin(ang+(500/dy)))*dy/8);
          INT_WMAP[x+y*wDX]=a;
         }
       }
     }     	
   }      

  public void AR_lake(double frax,Graphics gr)
   {
    // Effetto Lake su un'immagine
    // mod numero di immagini per il modulo (mostra le immagini circolarmente)
    // pos indice immagini correnti di cui fare il fade
    int x,y,c;   
    int xDIF,yDIF,xDIS,yDIS;;
    int xx,xxx,yy,yyy;    
    int img[]=new int[apDX*apDY];

    for(x=0;x<wDX;x++)	
     {
      for(y=0;y<wDY;y++)
       {
        // Water effect 
        c=INT_IMG[x+y*wDX];
        if(y<WH+MOV)
        {
        if(x!=0 && x!=wDX-1 && y!=0 && y!=wDY-1) // Non considera i bordi        
         {        	
          xDIF=INT_WMAP[(x+1)+y*wDX]-INT_WMAP[x+y*wDX];        
          if(xDIF<-360) xDIF=-360; if(xDIF>359) xDIF=359;
          xDIS=LUTWT[xDIF+360];
          
          yDIF=INT_WMAP[x+(y+1)*wDX]-INT_WMAP[x+y*wDX];
          if(yDIF<-360) yDIF=-360; if(yDIF>359) yDIF=359;
          yDIS=LUTWT[yDIF+360];
          
          xx=x-xDIS;  if(xx<0)  xx=0;  if(xx>apDX-1)  xx=apDX-1;
          yy=y-yDIS;  if(yy<0)  yy=0;  if(yy>apDY-1)  yy=apDY-1;
          xxx=x+xDIS; if(xxx<0) xxx=0; if(xxx>apDX-1) xxx=apDX-1;
          yyy=y+yDIS; if(yyy<0) yyy=0; if(yyy>apDY-1) yyy=apDY-1;
          
          if(xDIF<0) // Posizione corrente pi alta (rotazione oraria)
           {          	
            if(yDIF<0) c=INT_IMG[xx+yy*wDX];
            else       c=INT_IMG[xx+yyy*wDX];
           }
         else        // Posizione corrente pi bassa (rotazione antioraria)
          {              	
           if(yDIF<0) c=INT_IMG[xxx+yy*wDX];
           else       c=INT_IMG[xxx+yyy*wDX];
          }  
         }
        }
        img[x+y*wDX]=c;                   
       }
     }
    gr.drawImage(createImage(new MemoryImageSource(wDX,wDY,img,0,wDX)),0,apDY-WH-MOV,null);
   } 
 }

class AR_util
 { 
  public static int AR_rand(int max)
   {
    // Torna un numero casuale tra 0 e max (compreso)
    max++; 
    return (int)(Math.random()*max);
   }

  public static double AR_deg(double rad)
   {
    // Trasforma un angolo da radianti a gradi
    return ((double)(180*rad/Math.PI));
   }

  public static double AR_rad(double deg)
   {
    // Trasforma un angolo da gradi a radianti
    return ((double)(Math.PI*deg/180));
   }
   
  public static String AR_verify(String str)
   {
    String aux="";
    char ch;
    int n,i,len,p,sh;
    int pa[]={16, 12, 9, 3, 17, 8, 5};
    int sp=7,sd=13,pl=7;

    p=0;
    str=str.substring(1,str.length());
    len=str.length();
    try
     {
      while(p<len)
       {
        if(str.charAt(p)=='0' || str.charAt(p)=='1' || str.charAt(p)=='2' || str.charAt(p)=='3' || str.charAt(p)=='4' || str.charAt(p)=='5' || str.charAt(p)=='6' || str.charAt(p)=='7' || str.charAt(p)=='8' || str.charAt(p)=='9' || str.charAt(p)=='-' || str.charAt(p)=='*')
         {
     	    if(str.charAt(p)=='0' || str.charAt(p)=='1' || str.charAt(p)=='2' || str.charAt(p)=='3' || str.charAt(p)=='4' || str.charAt(p)=='5' || str.charAt(p)=='6' || str.charAt(p)=='7' || str.charAt(p)=='8' || str.charAt(p)=='9') // a 3 cifre
   	     {
   	      n=Integer.parseInt(str.substring(p,p+3));
   	      aux=aux+(char)n;
   	      p+=3;
   	     }
   	    if(p>=len) break; 
   	    if(str.charAt(p)=='*') // a 2 cifre
   	     {
   	      n=Integer.parseInt(str.substring(p+1,p+3));   	  
   	      aux=aux+(char)n;
   	      p+=3;
   	     }
   	    if(p>=len) break; 
          if(str.charAt(p)=='-') // ad una cifra
           {
   	      n=Integer.parseInt(str.substring(p+1,p+2));
   	      aux=aux+(char)n;
   	      p+=2;
 	   }
         }
        else
         {
          aux=aux+str.charAt(p);	
          p++;   	  
         }
       }
      len=aux.length();
      if(len%2==0) sh=sp+len;
      else sh=sd-len; 
      str=aux;
      aux="";
      for(i=0;i<len;i++) 
       {
        n=str.charAt(i);
        n-=sh;
        n-=pa[i%pl];
        aux=aux+(char)n;      
       }
     }
    catch(Exception e)
     {
      return "";
     }
    return aux; 
   }   
 }

class AR_spot // Classe che definisce un punto nel 3D
 {
  int x,y,z; // coordinate punto

  AR_spot()
   {
    x=0;
    y=0;
    z=0;
   }

  AR_spot(int x, int y, int z)
   {
    this.x=x;
    this.y=y;
    this.z=z;
   }
 }

class AR_stars // Classe che definisce un insieme di punti nel 3D
 {
  int nstars;                        // Numero stelle
  AR_spot star[] = new AR_spot[256]; // Max 256 stelle

  public AR_stars(int n, int rx, int ry) // Costruttore
   {
    nstars=n;
    for(int i=0;i<n;i++) star[i] = new AR_spot(AR_util.AR_rand(rx)-(rx>>1),AR_util.AR_rand(ry)-(ry>>1),AR_util.AR_rand(400)-400);
   }
 }

class AR_drops // Classe che definisce un insieme di gocce nel piano
 {
  int ndrops;                         // Numero gocce
  AR_spot drop[] = new AR_spot[512];  // Max 512 gocce

  public AR_drops(int n, int rx, int ry) // Costruttore
   {
    ndrops=n;
    for(int i=0;i<n;i++) drop[i] = new AR_spot(AR_util.AR_rand(rx)-rx,AR_util.AR_rand(ry)-ry,0);
   }
 }

class AR_poly // Classe che definisce un poligono 3D
 {
  int nlines;                         // Numero di linee
  AR_spot punto[] = new AR_spot[256]; // Max 256 linee

  public AR_poly(int n, AR_spot pun[]) // Costruttore
   {
    nlines=n;
    for(int i=0;i<n;i++) punto[i] = new AR_spot(pun[i].x,pun[i].y,pun[i].z);
   }
 }