import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;

public class WM_Starscroll extends Applet implements Runnable
 {
  // Variabili relative all'applet
  String VER="1.18";
  int _fi=0;
  Image IMG,FG_IMG;
  Dimension apDIM;
  int apDX,apDY;   
  //String REGCODE;
  String TARGET;  
  double SP;
  int FG_X,FG_Y,TEXTPOS,BTXTPOS,TEXTF; 
  int WIRE,FILL,NUM,TEXTH,DIR,TEXTV,ZU,ANGLE,POS,OMBRA;
  Color TEXTCOL,COL1,COL2,COL3,BTEXTCOL;
  String TEXT=null,BTEXT=null,URL=null,LINEE=null;  
  int SX,RX,RY,RZ;
  Font f1 = new Font("TimesRoman",Font.PLAIN,12);
  Font f2;

  // Variabili per il thread e temporizzazione
  Thread RUN;
  long TIME,TFPS;
  int FPS,PFPS;

  // Variabili per il doppio buffer
  Image VSCREEN;   
  Graphics GVSCREEN;

  // Look Up Table
  double LUTC[]=new double[360]; // LUT del coseno
  double LUTS[]=new double[360]; // LUT del seno

  // Oggetti 3D
  AR_poly Alf[] = new AR_poly[256]; // Codici ascii da 0 a 255
  
  public void init()
   {
    // Carica lo sfondo e i parametri
    try 
     {
      // Codice di registrazione
      //REGCODE =getParameter("regcode");
      // Parametri applet                            	
      IMG     =getImage(getDocumentBase(),getParameter("bgimg"));
      FG_IMG  =getImage(getDocumentBase(),getParameter("fgimg"));
      FG_X    =Integer.parseInt(getParameter("fgimgx"));
      FG_Y    =Integer.parseInt(getParameter("fgimgy"));                  
      LINEE   =getParameter("starscrolllines");
      SP      =Integer.parseInt(getParameter("starscrollsp"));
      SP=SP/10;
      ZU      =Integer.parseInt(getParameter("starscrollzoom"));
      ANGLE   =Integer.parseInt(getParameter("starscrollangle"));      
      ANGLE++;
      POS     =Integer.parseInt(getParameter("starscrollpos"));
      if(POS==0) POS=45;
      if(POS==1) POS=0;
      if(POS==2) POS=90+180+45;
      COL1    =new Color(Integer.parseInt(getParameter("starscrollcolw"),16));
      COL2    =new Color(Integer.parseInt(getParameter("starscrollcolf"),16));
      COL3    =new Color(Integer.parseInt(getParameter("starscrollcols"),16));
      WIRE    =Integer.parseInt(getParameter("starscrollwire"));
      FILL    =Integer.parseInt(getParameter("starscrollfill"));
      OMBRA   =Integer.parseInt(getParameter("starscrollshad"));
      // Parametri generali
      TEXT    =getParameter("scrolltext");
      TEXTH   =Integer.parseInt(getParameter("scrolltexth"));
      if(TEXTH<=4) TEXTH=36;
      DIR     =Integer.parseInt(getParameter("scrolltextdir"));
      TEXTV   =Integer.parseInt(getParameter("scrolltextsp"));
      TEXTPOS =Integer.parseInt(getParameter("scrolltextpos"));
      TEXTCOL =new Color(Integer.parseInt(getParameter("scrolltextcol"),16));
      TEXTF   =Integer.parseInt(getParameter("scrolltextfont"));
      BTEXT   =getParameter("bottomtext");
      BTEXTCOL=new Color(Integer.parseInt(getParameter("bottomtextcol"),16));
      BTXTPOS =Integer.parseInt(getParameter("bottomtextalign"));
      URL     =getParameter("urltolink");
      TARGET  =getParameter("urltarget");      
      MediaTracker tr=new MediaTracker(this);
      tr.addImage(IMG,0);
      tr.waitForID(0);
      tr.addImage(IMG,1);
      tr.waitForID(1);
     } catch(InterruptedException e) {};
     
    /*if(REGCODE.length()>=10)
     {
      if(getDocumentBase().toString().toUpperCase().startsWith("HTTP://"))
       {
        if(getDocumentBase().toString().substring(7).toUpperCase().indexOf(AR_util.AR_verify(REGCODE))!=-1) _fi=0;
       } 
      else 
       {
        if(getDocumentBase().toString().toUpperCase().indexOf(AR_util.AR_verify(REGCODE))!=-1) _fi=0;
       }
      if(AR_util.AR_verify(REGCODE).equals("")) _fi=1;
     } 
    else _fi=1;*/
    
    // Inizializza applet
    // setSize(320,200);
    apDIM=getSize();
    apDX=apDIM.width;         
    apDY=apDIM.height;
    if(_fi==1)
     {
      if(TEXTV<=0) TEXTV=1;
      if(TEXTH<=24) TEXTH=36;
     }    
    if(TEXTF==0) f2=new Font("TimesRoman",Font.BOLD,TEXTH);
    if(TEXTF==1) f2=new Font("Arial",Font.BOLD,TEXTH);
    if(TEXTF==2) f2=new Font("Courier",Font.BOLD,TEXTH);    
    if(_fi==1) TEXT="http://www.valarsoft.com";
    if(DIR==1) SX=-getFontMetrics(f2).stringWidth(TEXT); else SX=apDX;
    if(_fi==1) TEXTPOS=apDY>>1;

    // Inizializza il doppio buffer
    VSCREEN=createImage(apDX,apDY);
    GVSCREEN=VSCREEN.getGraphics();

    // Inizializza le LUT
    AR_setLUT();
    
    // Inizializza gli oggetti 3D        
    AR_spot pAlf[] = new AR_spot[24];
    
    // Codici ASCII da 0 a 31
    for(int i=0;i<=31;i++)
     {
      pAlf[0] = new AR_spot(0,0,0);
      Alf[i] = new AR_poly(1,pAlf);
     }

    // SPAZIO (ASCII=32)
    pAlf[0] = new AR_spot(0,0,0);
    Alf[32] = new AR_poly(1,pAlf);

    // Codici ASCII da 33 a 45
    for(int i=33;i<=45;i++)
     {
      pAlf[0] = new AR_spot(0,0,0);
      Alf[i] = new AR_poly(1,pAlf);
     }

    // . (ASCII=46)
    pAlf[0] = new AR_spot(-1,2,0);
    pAlf[1] = new AR_spot(-1,4,0);
    pAlf[2] = new AR_spot(1,4,0);
    pAlf[3] = new AR_spot(1,2,0);
    pAlf[4] = new AR_spot(-1,2,0);
    Alf[46] = new AR_poly(5,pAlf);

    // / (ASCII=47)
    pAlf[0] = new AR_spot(1,-4,0);
    pAlf[1] = new AR_spot(-3,4,0);
    pAlf[2] = new AR_spot(-1,4,0);
    pAlf[3] = new AR_spot(3,-4,0);
    pAlf[4] = new AR_spot(1,-4,0);
    Alf[47] = new AR_poly(5,pAlf);

    // 0 (ASCII=48)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(2,4,0);
    pAlf[2] = new AR_spot(3,3,0);
    pAlf[3] = new AR_spot(3,-3,0);
    pAlf[4] = new AR_spot(2,-4,0);
    pAlf[5] = new AR_spot(-2,-4,0);
    pAlf[6] = new AR_spot(-3,-3,0);
    pAlf[7] = new AR_spot(-3,3,0);
    pAlf[8] = new AR_spot(-2,4,0);
    Alf[48] = new AR_poly(9,pAlf);
    
    // 1 (ASCII=49)
    pAlf[0] = new AR_spot(-1,-4,0);
    pAlf[1] = new AR_spot(-3,-2,0);
    pAlf[2] = new AR_spot(-3,-1,0);
    pAlf[3] = new AR_spot(-1,-1,0);
    pAlf[4] = new AR_spot(-1,2,0);
    pAlf[5] = new AR_spot(-3,2,0);
    pAlf[6] = new AR_spot(-3,4,0);
    pAlf[7] = new AR_spot(3,4,0);
    pAlf[8] = new AR_spot(3,2,0);
    pAlf[9] = new AR_spot(1,2,0);
    pAlf[10]= new AR_spot(1,-4,0);
    pAlf[11]= new AR_spot(-1,-4,0);
    Alf[49] = new AR_poly(12,pAlf);

    // 2 (ASCII=50)
    pAlf[0] = new AR_spot(-1,-4,0);
    pAlf[1] = new AR_spot(-3,-2,0);
    pAlf[2] = new AR_spot(-3,-1,0);
    pAlf[3] = new AR_spot(-1,-1,0);
    pAlf[4] = new AR_spot(0,-2,0);
    pAlf[5] = new AR_spot(1,-1,0);
    pAlf[6] = new AR_spot(1,0,0);
    pAlf[7] = new AR_spot(-3,2,0);
    pAlf[8] = new AR_spot(-3,4,0);
    pAlf[9] = new AR_spot(3,4,0);
    pAlf[10]= new AR_spot(3,2,0);
    pAlf[11]= new AR_spot(-1,2,0);
    pAlf[12]= new AR_spot(3,0,0);
    pAlf[13]= new AR_spot(3,-2,0);
    pAlf[14]= new AR_spot(1,-4,0);
    pAlf[15]= new AR_spot(-1,-4,0);
    Alf[50] = new AR_poly(16,pAlf);

    // 3 (ASCII=51)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(-3,2,0);
    pAlf[3] = new AR_spot(-2,2,0);
    pAlf[4] = new AR_spot(-1,3,0);
    pAlf[5] = new AR_spot(0,2,0);
    pAlf[6] = new AR_spot(0,1,0);
    pAlf[7] = new AR_spot(-2,0,0);
    pAlf[8] = new AR_spot(0,-1,0);
    pAlf[9] = new AR_spot(0,-2,0);
    pAlf[10]= new AR_spot(-1,-3,0);
    pAlf[11]= new AR_spot(-2,-2,0);
    pAlf[12]= new AR_spot(-3,-2,0);
    pAlf[13]= new AR_spot(-3,-3,0);
    pAlf[14]= new AR_spot(-2,-4,0);
    pAlf[15]= new AR_spot(1,-4,0);
    pAlf[16]= new AR_spot(2,-3,0);
    pAlf[17]= new AR_spot(2,-1,0);
    pAlf[18]= new AR_spot(1,0,0);
    pAlf[19]= new AR_spot(2,1,0);
    pAlf[20]= new AR_spot(2,3,0);
    pAlf[21]= new AR_spot(1,4,0);
    pAlf[22]= new AR_spot(-2,4,0);
    Alf[51] = new AR_poly(23,pAlf);

    // 4 (ASCII=52)
    pAlf[0] = new AR_spot(0,-4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(0,3,0);
    pAlf[3] = new AR_spot(0,4,0);
    pAlf[4] = new AR_spot(2,4,0);
    pAlf[5] = new AR_spot(2,3,0);
    pAlf[6] = new AR_spot(3,3,0);
    pAlf[7] = new AR_spot(3,1,0);
    pAlf[8] = new AR_spot(2,1,0);
    pAlf[9] = new AR_spot(2,-4,0);
    pAlf[10]= new AR_spot(0,-4,0);
    Alf[52] = new AR_poly(11,pAlf);

    // 5 (ASCII=53)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,0,0);
    pAlf[2] = new AR_spot(-2,1,0);
    pAlf[3] = new AR_spot(1,1,0);
    pAlf[4] = new AR_spot(1,2,0);
    pAlf[5] = new AR_spot(-3,2,0);
    pAlf[6] = new AR_spot(-3,4,0);
    pAlf[7] = new AR_spot(2,4,0);
    pAlf[8] = new AR_spot(3,3,0);
    pAlf[9] = new AR_spot(3,0,0);
    pAlf[10]= new AR_spot(2,-1,0);
    pAlf[11]= new AR_spot(-1,-1,0);
    pAlf[12]= new AR_spot(-1,-2,0);
    pAlf[13]= new AR_spot(3,-2,0);
    pAlf[14]= new AR_spot(3,-4,0);
    pAlf[15]= new AR_spot(-3,-4,0);
    Alf[53] = new AR_poly(16,pAlf);

    // 6 (ASCII=54)
    pAlf[0] = new AR_spot(-1,-4,0);
    pAlf[1] = new AR_spot(-3,-2,0);
    pAlf[2] = new AR_spot(-3,3,0);
    pAlf[3] = new AR_spot(-2,4,0);
    pAlf[4] = new AR_spot(2,4,0);
    pAlf[5] = new AR_spot(3,3,0);
    pAlf[6] = new AR_spot(3,1,0);
    pAlf[7] = new AR_spot(2,0,0);
    pAlf[8] = new AR_spot(-1,0,0);
    pAlf[9] = new AR_spot(-1,-1,0);
    pAlf[10]= new AR_spot(0,-2,0);
    pAlf[11]= new AR_spot(1,-2,0);
    pAlf[12]= new AR_spot(1,-1,0);
    pAlf[13]= new AR_spot(3,-1,0);
    pAlf[14]= new AR_spot(3,-3,0);
    pAlf[15]= new AR_spot(2,-4,0);
    pAlf[16]= new AR_spot(-1,-4,0);
    Alf[54] = new AR_poly(17,pAlf);

    // 7 (ASCII=55)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,-2,0);
    pAlf[2] = new AR_spot(0,-2,0);
    pAlf[3] = new AR_spot(-3,4,0);
    pAlf[4] = new AR_spot(-1,4,0);
    pAlf[5] = new AR_spot(3,-4,0);
    pAlf[6] = new AR_spot(-3,-4,0);
    Alf[55] = new AR_poly(7,pAlf);

    // 8 (ASCII=56)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(-3,1,0);
    pAlf[3] = new AR_spot(-2,0,0);
    pAlf[4] = new AR_spot(-3,-1,0);
    pAlf[5] = new AR_spot(-3,-3,0);
    pAlf[6] = new AR_spot(-2,-4,0);
    pAlf[7] = new AR_spot(2,-4,0);
    pAlf[8] = new AR_spot(3,-3,0);
    pAlf[9] = new AR_spot(3,-1,0);
    pAlf[10]= new AR_spot(2,0,0);
    pAlf[11]= new AR_spot(3,1,0);
    pAlf[12]= new AR_spot(3,3,0);
    pAlf[13]= new AR_spot(2,4,0);
    pAlf[14]= new AR_spot(-2,4,0);
    Alf[56] = new AR_poly(15,pAlf);

    // 9 (ASCII=57)
    pAlf[0] = new AR_spot(1,4,0);
    pAlf[1] = new AR_spot(3,2,0);
    pAlf[2] = new AR_spot(3,-3,0);
    pAlf[3] = new AR_spot(2,-4,0);
    pAlf[4] = new AR_spot(-2,-4,0);
    pAlf[5] = new AR_spot(-3,-3,0);
    pAlf[6] = new AR_spot(-3,-1,0);
    pAlf[7] = new AR_spot(-2,0,0);
    pAlf[8] = new AR_spot(1,0,0);
    pAlf[9] = new AR_spot(1,1,0);
    pAlf[10]= new AR_spot(0,2,0);
    pAlf[11]= new AR_spot(-1,2,0);
    pAlf[12]= new AR_spot(-1,1,0);
    pAlf[13]= new AR_spot(-3,1,0);
    pAlf[14]= new AR_spot(-3,3,0);
    pAlf[15]= new AR_spot(-2,4,0);
    pAlf[16]= new AR_spot(1,4,0);
    Alf[57] = new AR_poly(17,pAlf);

    // Codici ASCII da 58 a 63
    for(int i=58;i<=63;i++)
     {
      pAlf[0] = new AR_spot(0,0,0);
      Alf[i] = new AR_poly(1,pAlf);
     }

    // @ (ASCII=64)
    pAlf[0] = new AR_spot(-2,-3,0);
    pAlf[1] = new AR_spot(-2,2,0);
    pAlf[2] = new AR_spot(0,4,0);
    pAlf[3] = new AR_spot(2,4,0);
    pAlf[4] = new AR_spot(3,3,0);
    pAlf[5] = new AR_spot(3,2,0);  
    pAlf[6] = new AR_spot(2,3,0);
    pAlf[7] = new AR_spot(1,3,0); 
    pAlf[8] = new AR_spot(0,2,0);
    pAlf[9] = new AR_spot(-1,1,0);
    pAlf[10]= new AR_spot(-1,-1,0);
    pAlf[11]= new AR_spot(0,-2,0);
    pAlf[12] = new AR_spot(2,-2,0);
    pAlf[13] = new AR_spot(2,-1,0);
    pAlf[14] = new AR_spot(1,0,0);
    pAlf[15] = new AR_spot(1,-1,0);
    pAlf[16] = new AR_spot(0,-1,0);
    pAlf[17] = new AR_spot(0,1,0);
    pAlf[18] = new AR_spot(1,1,0);
    pAlf[19] = new AR_spot(3,-1,0);
    pAlf[20] = new AR_spot(3,-3,0);
    pAlf[21] = new AR_spot(2,-4,0);
    pAlf[22] = new AR_spot(-1,-4,0);
    pAlf[23] = new AR_spot(-2,-3,0);
    Alf[64] = new AR_poly(24,pAlf);

    // A (ASCII=65)
    pAlf[0] = new AR_spot(-1,-4,0);
    pAlf[1] = new AR_spot(1,-4,0);
    pAlf[2] = new AR_spot(3,4,0);
    pAlf[3] = new AR_spot(2,4,0);
    pAlf[4] = new AR_spot(1,2,0);
    pAlf[5] = new AR_spot(-1,2,0);
    pAlf[6] = new AR_spot(-2,4,0);
    pAlf[7] = new AR_spot(-3,4,0);
    pAlf[8] = new AR_spot(-1,-4,0);
    Alf[65] = new AR_poly(9,pAlf);

    // B (ASCII=66)
    pAlf[0] = new AR_spot(-2,-4,0);
    pAlf[1] = new AR_spot(2,-4,0);
    pAlf[2] = new AR_spot(3,-3,0);
    pAlf[3] = new AR_spot(3,-2,0);
    pAlf[4] = new AR_spot(0,0,0);
    pAlf[5] = new AR_spot(3,2,0);
    pAlf[6] = new AR_spot(3,3,0);
    pAlf[7] = new AR_spot(2,4,0);
    pAlf[8] = new AR_spot(-2,4,0);
    pAlf[9] = new AR_spot(-2,-4,0);
    Alf[66] = new AR_poly(10,pAlf);
    
    // C (ASCII=67)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(-3,-3,0);
    pAlf[3] = new AR_spot(-2,-4,0);
    pAlf[4] = new AR_spot(3,-4,0);
    pAlf[5] = new AR_spot(3,-2,0);
    pAlf[6] = new AR_spot(0,-2,0);
    pAlf[7] = new AR_spot(0,2,0);
    pAlf[8] = new AR_spot(3,2,0);
    pAlf[9] = new AR_spot(3,4,0);
    pAlf[10]= new AR_spot(-2,4,0);
    Alf[67] = new AR_poly(11,pAlf);

    // D (ASCII=68)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(-2,-4,0);
    pAlf[2] = new AR_spot(1,-4,0);
    pAlf[3] = new AR_spot(2,-3,0);
    pAlf[4] = new AR_spot(3,-1,0);
    pAlf[5] = new AR_spot(3,1,0);
    pAlf[6] = new AR_spot(2,3,0);
    pAlf[7] = new AR_spot(1,4,0);
    pAlf[8] = new AR_spot(-2,4,0);
    Alf[68] = new AR_poly(9,pAlf);

    // E (ASCII=69)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(-2,-4,0);
    pAlf[2] = new AR_spot(3,-4,0);
    pAlf[3] = new AR_spot(3,-2,0);
    pAlf[4] = new AR_spot(0,-2,0);
    pAlf[5] = new AR_spot(0,-1,0);
    pAlf[6] = new AR_spot(2,-1,0);
    pAlf[7] = new AR_spot(2,1,0);
    pAlf[8] = new AR_spot(0,1,0);
    pAlf[9] = new AR_spot(0,2,0);
    pAlf[10]= new AR_spot(3,2,0);
    pAlf[11]= new AR_spot(3,4,0);
    pAlf[12]= new AR_spot(-2,4,0);
    Alf[69] = new AR_poly(13,pAlf);

    // F (ASCII=70)
    pAlf[0] = new AR_spot(-2,-4,0);
    pAlf[1] = new AR_spot(-2,4,0);
    pAlf[2] = new AR_spot(0,4,0);
    pAlf[3] = new AR_spot(0,1,0);
    pAlf[4] = new AR_spot(2,1,0);
    pAlf[5] = new AR_spot(2,-1,0);
    pAlf[6] = new AR_spot(0,-1,0);
    pAlf[7] = new AR_spot(0,-2,0);
    pAlf[8] = new AR_spot(3,-2,0);
    pAlf[9] = new AR_spot(3,-4,0);
    pAlf[10]= new AR_spot(-2,-4,0);
    Alf[70]  = new AR_poly(11,pAlf);
    
    // G (ASCII=71)
    pAlf[0] = new AR_spot(-2,-4,0);
    pAlf[1] = new AR_spot(-3,-3,0);
    pAlf[2] = new AR_spot(-3,3,0);
    pAlf[3] = new AR_spot(-2,4,0);
    pAlf[4] = new AR_spot(2,4,0);
    pAlf[5] = new AR_spot(3,3,0);
    pAlf[6] = new AR_spot(3,0,0);
    pAlf[7] = new AR_spot(0,0,0);
    pAlf[8] = new AR_spot(0,1,0);
    pAlf[9] = new AR_spot(1,1,0);
    pAlf[10]= new AR_spot(1,2,0);
    pAlf[11]= new AR_spot(-1,2,0);
    pAlf[12]= new AR_spot(-1,-2,0);
    pAlf[13]= new AR_spot(3,-2,0);
    pAlf[14]= new AR_spot(3,-3,0);
    pAlf[15]= new AR_spot(2,-4,0);
    pAlf[16]= new AR_spot(-2,-4,0);
    Alf[71] = new AR_poly(17,pAlf);

    // H (ASCII=72)
    pAlf[0] = new AR_spot(-3,4,0);
    pAlf[1] = new AR_spot(-3,-4,0);
    pAlf[2] = new AR_spot(-1,-4,0);
    pAlf[3] = new AR_spot(-1,-1,0);
    pAlf[4] = new AR_spot(1,-1,0);
    pAlf[5] = new AR_spot(1,-4,0);
    pAlf[6] = new AR_spot(3,-4,0);
    pAlf[7] = new AR_spot(3,4,0);
    pAlf[8] = new AR_spot(1,4,0);
    pAlf[9] = new AR_spot(1,1,0);
    pAlf[10]= new AR_spot(-1,1,0);
    pAlf[11]= new AR_spot(-1,4,0);
    pAlf[12]= new AR_spot(-3,4,0);
    Alf[72] = new AR_poly(13,pAlf);

    // I (ASCII=73)
    pAlf[0] = new AR_spot(-1,4,0);
    pAlf[1] = new AR_spot(-1,-4,0);
    pAlf[2] = new AR_spot(1,-4,0);
    pAlf[3] = new AR_spot(1,4,0);
    pAlf[4] = new AR_spot(-1,4,0);
    Alf[73] = new AR_poly(5,pAlf);

    // J (ASCII=74)
    pAlf[0] = new AR_spot(-2,1,0);
    pAlf[1] = new AR_spot(-2,3,0);
    pAlf[2] = new AR_spot(-1,4,0);
    pAlf[3] = new AR_spot(2,4,0);
    pAlf[4] = new AR_spot(3,3,0);
    pAlf[5] = new AR_spot(3,-4,0);
    pAlf[6] = new AR_spot(1,-4,0);
    pAlf[7] = new AR_spot(1,2,0);
    pAlf[8] = new AR_spot(0,2,0);
    pAlf[9] = new AR_spot(0,1,0);
    pAlf[10]= new AR_spot(-2,1,0);
    Alf[74] = new AR_poly(11,pAlf);

    // K (ASCII=75)
    pAlf[0] = new AR_spot(-3,4,0);
    pAlf[1] = new AR_spot(-3,-4,0);
    pAlf[2] = new AR_spot(-1,-4,0);
    pAlf[3] = new AR_spot(-1,-1,0);
    pAlf[4] = new AR_spot(2,-4,0);
    pAlf[5] = new AR_spot(3,-3,0);
    pAlf[6] = new AR_spot(0,0,0);
    pAlf[7] = new AR_spot(3,3,0);
    pAlf[8] = new AR_spot(2,4,0);
    pAlf[9] = new AR_spot(-1,1,0);
    pAlf[10]= new AR_spot(-1,4,0);
    pAlf[11]= new AR_spot(-3,4,0);
    Alf[75] = new AR_poly(12,pAlf);

    // L (ASCII=76)
    pAlf[0] = new AR_spot(-2,-4,0);
    pAlf[1] = new AR_spot(-2,4,0);
    pAlf[2] = new AR_spot(3,4,0);
    pAlf[3] = new AR_spot(3,2,0);
    pAlf[4] = new AR_spot(0,2,0);
    pAlf[5] = new AR_spot(0,-4,0);
    pAlf[6] = new AR_spot(-2,-4,0);
    Alf[76] = new AR_poly(7,pAlf);

    // M (ASCII=77)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,4,0);
    pAlf[2] = new AR_spot(-1,4,0);
    pAlf[3] = new AR_spot(-1,-1,0);
    pAlf[4] = new AR_spot(0,0,0);
    pAlf[5] = new AR_spot(1,-1,0);
    pAlf[6] = new AR_spot(1,4,0);
    pAlf[7] = new AR_spot(3,4,0);
    pAlf[8] = new AR_spot(3,-4,0);
    pAlf[9] = new AR_spot(1,-4,0);
    pAlf[10]= new AR_spot(0,-3,0);
    pAlf[11]= new AR_spot(-1,-4,0);
    pAlf[12]= new AR_spot(-3,-4,0);
    Alf[77] = new AR_poly(13,pAlf);

    // N (ASCII=78)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,4,0);
    pAlf[2] = new AR_spot(-1,4,0);
    pAlf[3] = new AR_spot(-1,-1,0);
    pAlf[4] = new AR_spot(1,4,0);
    pAlf[5] = new AR_spot(3,4,0);
    pAlf[6] = new AR_spot(3,-4,0);
    pAlf[7] = new AR_spot(1,-4,0);
    pAlf[8] = new AR_spot(1,1,0);
    pAlf[9] = new AR_spot(-1,-4,0);
    pAlf[10]= new AR_spot(-3,-4,0);
    Alf[78] = new AR_poly(11,pAlf);

    // O (ASCII=79)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(2,4,0);
    pAlf[2] = new AR_spot(3,3,0);
    pAlf[3] = new AR_spot(3,-3,0);
    pAlf[4] = new AR_spot(2,-4,0);
    pAlf[5] = new AR_spot(-2,-4,0);
    pAlf[6] = new AR_spot(-3,-3,0);
    pAlf[7] = new AR_spot(-3,3,0);
    pAlf[8] = new AR_spot(-2,4,0);
    Alf[79] = new AR_poly(9,pAlf);

    // P (ASCII=80)
    pAlf[0] = new AR_spot(-2,-4,0);
    pAlf[1] = new AR_spot(-2,4,0);
    pAlf[2] = new AR_spot(0,4,0);
    pAlf[3] = new AR_spot(0,0,0);
    pAlf[4] = new AR_spot(2,0,0);
    pAlf[5] = new AR_spot(3,-1,0);
    pAlf[6] = new AR_spot(3,-3,0);
    pAlf[7] = new AR_spot(2,-4,0);
    pAlf[8] = new AR_spot(-2,-4,0);
    Alf[80] = new AR_poly(9,pAlf);
    
    // Q (ASCII=81)
    pAlf[0] = new AR_spot(1,-4,0);
    pAlf[1] = new AR_spot(-2,-4,0);
    pAlf[2] = new AR_spot(-3,-3,0);
    pAlf[3] = new AR_spot(-3,3,0);
    pAlf[4] = new AR_spot(-2,4,0);
    pAlf[5] = new AR_spot(2,4,0);
    pAlf[6] = new AR_spot(3,3,0);
    pAlf[7] = new AR_spot(2,2,0);
    pAlf[8] = new AR_spot(2,-3,0);
    pAlf[9] = new AR_spot(1,-4,0);
    Alf[81] = new AR_poly(10,pAlf);

    // R (ASCII=82)
    pAlf[0] = new AR_spot(-2,-4,0);
    pAlf[1] = new AR_spot(-2,4,0);
    pAlf[2] = new AR_spot(0,4,0);
    pAlf[3] = new AR_spot(0,1,0);
    pAlf[4] = new AR_spot(2,4,0);
    pAlf[5] = new AR_spot(3,4,0);
    pAlf[6] = new AR_spot(3,3,0);
    pAlf[7] = new AR_spot(1,0,0);
    pAlf[8] = new AR_spot(2,0,0);
    pAlf[9] = new AR_spot(3,-1,0);
    pAlf[10] = new AR_spot(3,-3,0);
    pAlf[11]= new AR_spot(2,-4,0);
    pAlf[12]= new AR_spot(-2,-4,0);
    Alf[82] = new AR_poly(13,pAlf);

    // S (ASCII=83)
    pAlf[0] = new AR_spot(-3,-3,0);
    pAlf[1] = new AR_spot(-3,-1,0);
    pAlf[2] = new AR_spot(0,1,0);
    pAlf[3] = new AR_spot(0,2,0);
    pAlf[4] = new AR_spot(-1,2,0);
    pAlf[5] = new AR_spot(-1,1,0);
    pAlf[6] = new AR_spot(-3,1,0);
    pAlf[7] = new AR_spot(-3,3,0);
    pAlf[8] = new AR_spot(-2,4,0);
    pAlf[9] = new AR_spot(2,4,0);
    pAlf[10]= new AR_spot(3,3,0);
    pAlf[11]= new AR_spot(3,1,0);
    pAlf[12]= new AR_spot(0,-1,0);
    pAlf[13]= new AR_spot(0,-2,0);
    pAlf[14]= new AR_spot(1,-2,0);
    pAlf[15]= new AR_spot(1,-1,0);
    pAlf[16]= new AR_spot(3,-1,0);
    pAlf[17]= new AR_spot(3,-3,0);
    pAlf[18]= new AR_spot(2,-4,0);
    pAlf[19]= new AR_spot(-2,-4,0);
    pAlf[20]= new AR_spot(-3,-3,0);
    Alf[83] = new AR_poly(21,pAlf);
    
    // T (ASCII=84)
    pAlf[0] = new AR_spot(1,4,0);
    pAlf[1] = new AR_spot(-1,4,0);
    pAlf[2] = new AR_spot(-1,-2,0);
    pAlf[3] = new AR_spot(-3,-2,0);
    pAlf[4] = new AR_spot(-3,-4,0);
    pAlf[5] = new AR_spot(3,-4,0);
    pAlf[6] = new AR_spot(3,-2,0);
    pAlf[7] = new AR_spot(1,-2,0);
    pAlf[8] = new AR_spot(1,4,0);
    Alf[84] = new AR_poly(9,pAlf);

    // U (ASCII=85)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(-2,4,0);
    pAlf[3] = new AR_spot(2,4,0);
    pAlf[4] = new AR_spot(3,3,0);
    pAlf[5] = new AR_spot(3,-4,0);
    pAlf[6] = new AR_spot(1,-4,0);
    pAlf[7] = new AR_spot(1,2,0);
    pAlf[8] = new AR_spot(-1,2,0);
    pAlf[9] = new AR_spot(-1,-4,0);
    pAlf[10]= new AR_spot(-3,-4,0);
    Alf[85] = new AR_poly(11,pAlf);

    // V (ASCII=86)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,-3,0);
    pAlf[2] = new AR_spot(-1,4,0);
    pAlf[3] = new AR_spot(1,4,0);
    pAlf[4] = new AR_spot(3,-3,0);
    pAlf[5] = new AR_spot(3,-4,0);
    pAlf[6] = new AR_spot(1,-4,0);
    pAlf[7] = new AR_spot(1,-3,0);
    pAlf[8] = new AR_spot(0,2,0);
    pAlf[9] = new AR_spot(-1,-3,0);
    pAlf[10]= new AR_spot(-1,-4,0);
    pAlf[11]= new AR_spot(-3,-4,0);
    Alf[86] = new AR_poly(12,pAlf);
    
    // W (ASCII=87)
    pAlf[0] = new AR_spot(-2,4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(-3,-4,0);
    pAlf[3] = new AR_spot(-2,-4,0);
    pAlf[4] = new AR_spot(-1,1,0);
    pAlf[5] = new AR_spot(0,0,0);
    pAlf[6] = new AR_spot(1,1,0);
    pAlf[7] = new AR_spot(2,-4,0);
    pAlf[8] = new AR_spot(3,-4,0);
    pAlf[9] = new AR_spot(3,3,0);
    pAlf[10] = new AR_spot(2,4,0);
    pAlf[11] = new AR_spot(1,4,0);
    pAlf[12]= new AR_spot(0,3,0);
    pAlf[13]= new AR_spot(-1,4,0);
    pAlf[14]= new AR_spot(-2,4,0);
    Alf[87] = new AR_poly(15,pAlf);
    
    // X (ASCII=88)
    pAlf[0] = new AR_spot(-3,4,0);
    pAlf[1] = new AR_spot(-3,3,0);
    pAlf[2] = new AR_spot(-1,0,0);
    pAlf[3] = new AR_spot(-3,-3,0);
    pAlf[4] = new AR_spot(-3,-4,0);
    pAlf[5] = new AR_spot(-1,-4,0);
    pAlf[6] = new AR_spot(-1,-3,0);
    pAlf[7] = new AR_spot(0,-1,0);
    pAlf[8] = new AR_spot(1,-3,0);
    pAlf[9] = new AR_spot(1,-4,0);
    pAlf[10]= new AR_spot(3,-4,0);
    pAlf[11]= new AR_spot(3,-3,0);
    pAlf[12]= new AR_spot(1,0,0);
    pAlf[13]= new AR_spot(3,3,0);
    pAlf[14]= new AR_spot(3,4,0);
    pAlf[15]= new AR_spot(1,4,0);
    pAlf[16]= new AR_spot(1,3,0);
    pAlf[17]= new AR_spot(0,1,0);
    pAlf[18]= new AR_spot(-1,3,0);
    pAlf[19]= new AR_spot(-1,4,0);
    pAlf[20]= new AR_spot(-3,4,0);
    Alf[88] = new AR_poly(21,pAlf);
    
    // Y (ASCII=89)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,-3,0);
    pAlf[2] = new AR_spot(-1,0,0);
    pAlf[3] = new AR_spot(-1,4,0);
    pAlf[4] = new AR_spot(1,4,0);
    pAlf[5] = new AR_spot(1,0,0);
    pAlf[6] = new AR_spot(3,-3,0);
    pAlf[7] = new AR_spot(3,-4,0);
    pAlf[8] = new AR_spot(1,-4,0);
    pAlf[9] = new AR_spot(1,-3,0);
    pAlf[10]= new AR_spot(0,-1,0);
    pAlf[11]= new AR_spot(-1,-3,0);
    pAlf[12]= new AR_spot(-1,-4,0);
    pAlf[13]= new AR_spot(-3,-4,0);
    Alf[89] = new AR_poly(14,pAlf);

    // Z (ASCII=90)
    pAlf[0] = new AR_spot(-3,-4,0);
    pAlf[1] = new AR_spot(-3,-2,0);
    pAlf[2] = new AR_spot(1,-2,0);
    pAlf[3] = new AR_spot(-3,2,0);
    pAlf[4] = new AR_spot(-3,4,0);
    pAlf[5] = new AR_spot(3,4,0);
    pAlf[6] = new AR_spot(3,2,0);
    pAlf[7] = new AR_spot(-1,2,0);
    pAlf[8] = new AR_spot(3,-2,0);
    pAlf[9] = new AR_spot(3,-4,0);
    pAlf[10]= new AR_spot(-3,-4,0);
    Alf[90] = new AR_poly(11,pAlf);

    // Codici ASCII da 91 a 96
    for(int i=91;i<=96;i++)
     {
      pAlf[0] = new AR_spot(0,0,0);
      Alf[i] = new AR_poly(1,pAlf);
     }

    // Codici ASCII da 97 a 122 (alfabeto minuscolo)
    for(int i=97;i<=122;i++) Alf[i] =Alf[i-32];
    
   }

  public void start()
   {
    RUN=new Thread(this);
    RUN.setPriority(RUN.MIN_PRIORITY);
    RUN.start();
   }

  public void run()
   {
    int i=0,j,ch,lines,p,zmax;    
    StringTokenizer str = new StringTokenizer(LINEE,"|");
    String line[]=new String[str.countTokens()]; // Linee
    double pl[]=new double[str.countTokens()];   // Profondit linee
    lines=str.countTokens();
    getGraphics().drawString("Loading...",1,apDY-4);
    while(str.hasMoreTokens())
     {	
      line[i]=str.nextToken();
      pl[i]=(105+(10*i))*ZU; 
      i++;
     }
    zmax=-3*lines*10; 
    while(true)
     {      
      // Corpo del programma
      //AR_clear(GVSCREEN,Color.black);
      GVSCREEN.drawImage(IMG,0,0,null);
      GVSCREEN.setColor(BTEXTCOL);
      // Range di profondit da zmax a + 105
      for(j=0;j<lines;j++)
       {
        for(i=0;i<line[j].length();i++)
         {
          ch=line[j].charAt(i);
       	  if(pl[j]<=105) 
       	   { 
       	    // Centrato
       	    p=7*(i-line[j].length()/2)*ZU; 
       	    if(line[j].length()%2==0) p=p+3*ZU;
            if(OMBRA==1) AR_fill_poly((apDX>>1)+4,(apDY>>1)+4,p,(int)pl[j],0,90+ANGLE,0,POS,COL3,Alf[ch],ZU,GVSCREEN);
       	    if(FILL==1)  AR_fill_poly((apDX>>1),(apDY>>1),p,(int)pl[j],0,90+ANGLE,0,POS,COL1,Alf[ch],ZU,GVSCREEN);
       	    if(WIRE==1)  AR_wire_poly((apDX>>1),(apDY>>1),p,(int)pl[j],0,90+ANGLE,0,POS,COL2,Alf[ch],ZU,GVSCREEN);       	  
       	   }
         }
        pl[j]-=SP; if(pl[j]<=zmax) pl[j]=105*ZU;
       }  
      GVSCREEN.setColor(BTEXTCOL);
      System.gc();      
      if(_fi==1) GVSCREEN.drawString("Webmatic Starscroll "+VER+" (demo)",1,apDY-4);
      else
       {       	
       	if(BTXTPOS==0) GVSCREEN.drawString(BTEXT,1,apDY-4); // Left
       	if(BTXTPOS==1) GVSCREEN.drawString(BTEXT,(apDX-getFontMetrics(f1).stringWidth(BTEXT))/2,apDY-4); // Center
       	if(BTXTPOS==2) GVSCREEN.drawString(BTEXT,apDX-getFontMetrics(f1).stringWidth(BTEXT),apDY-4); // Right
       }      
      GVSCREEN.drawImage(FG_IMG,FG_X,FG_Y,null); // Immagine in primo piano (logo)                    
      GVSCREEN.setFont(f2);
      GVSCREEN.setColor(TEXTCOL);
      GVSCREEN.drawString(TEXT,SX,TEXTPOS);
      GVSCREEN.setColor(BTEXTCOL);
      if(DIR==1) 
       {
        SX+=TEXTV;
        if(SX>=apDX) SX=-getFontMetrics(f2).stringWidth(TEXT);
       }
      else
       {
        SX-=TEXTV;
        if(SX<=-getFontMetrics(f2).stringWidth(TEXT)) SX=apDX;
       }
      GVSCREEN.setFont(f1);
      AR_waitfps(60);           // Sincronizza i frame per secondo
      paint(getGraphics());     // Manda a video
      try
       {
        RUN.yield();
       } catch(Exception e) {};   
     }
   }

  public void stop()
   {
    RUN.stop();
   }

  public String getAppletInfo()
   {
    return "Webmatic Starscroll "+VER+" by Amuso Raffaele - http://www.valarsoft.com";
   }

  public final boolean mouseUp(Event e, int x, int y)
   {
    try
     {          
      URL link;
      if(_fi==0)
       {
        link=new URL(getCodeBase(),URL);
        if(URL.compareTo("")!=0) getAppletContext().showDocument(link,TARGET);
       } 
      else
       {
        link=new URL(getCodeBase(),"http://www.valarsoft.com");
        getAppletContext().showDocument(link,"_blank");
       }
     } catch(MalformedURLException ex) {};
    return true;
   }

  public void paint(Graphics g)
   {
    g.drawImage(VSCREEN,0,0,null); // Stampa il buffer nel video (potrei stampare piu' di un buffer, basta duplicare la linea e riferirsi ad un altro buffer buf)
   }

  // ================= LIBRERIA =======================================================

  public synchronized final void AR_waitfps(int maxfps) // Sincronizza i frame per secondo
   {
    long ms=1000/maxfps;
    long mdif=System.currentTimeMillis()-TIME;

    if(mdif<ms)
     {
      try 
       { 
        RUN.sleep(ms-mdif); 
       } catch (InterruptedException e) {};
     }
    // Stampa fps
    TFPS+=System.currentTimeMillis()-TIME;
    FPS++;
    if(TFPS>=1000) { TFPS=0; PFPS=FPS; FPS=0; }
    if(_fi==1) GVSCREEN.drawString("fps: "+String.valueOf(PFPS),apDX-getFontMetrics(f1).stringWidth("fps: "+String.valueOf(PFPS)),11);
    // Coglie l'attimo
    TIME=System.currentTimeMillis();
   }

  public void AR_setLUT() // Prepara le LUT del seno e del coseno
   {
    int i; 
 
    for(i=0;i<360;i++)
     {
      LUTC[i]=Math.cos(AR_util.AR_rad(i));
      LUTS[i]=Math.sin(AR_util.AR_rad(i));
     }
   }

  public void AR_clear(Graphics g, Color c)
   {
    g.setColor(c);
    g.fillRect(0,0,apDX,apDY);
   }

  public void AR_putpx(Graphics g, int x, int y, Color c)
   {
    // Disegna un pixel
    g.setColor(c);
    g.drawLine(x,y,x,y);
   }

  public void AR_line(int px, int py, int cx, int cy, int cz, int rx, int ry, int rz, Color Col, int Xa, int Ya, int Za, int Xb, int Yb, int Zb, int zo, Graphics g)
   {
    // Stampa una linea con
    // px,py posizione sullo schermo
    // cx,cy,cz traslazione nello spazio
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // zo fattore di zoom
    // Col colore delle stelle
    // g schermo dove stampare il tutto
    int x1,y1,z1,x2,y2,z2;                            // Punti da unire con una linea
    double xa,ya,za,xb,yb,zb,xa1,ya1,za1,xb1,yb1,zb1; // Variabili per i calcoli
    double ta,tb;                                     // Variabili per la prospettiva
    int d=128;                                        // Distanza dall'occhio

    x1=Xa*zo+cx; y1=Ya*zo+cy; z1=Za*zo+cz;
    x2=Xb*zo+cx; y2=Yb*zo+cy; z2=Zb*zo+cz;
    // Rotazione lungo asse X
    ya1=y1*LUTC[rx]+z1*LUTS[rx];
    za1=y1*LUTS[rx]-z1*LUTC[rx];
    yb1=y2*LUTC[rx]+z2*LUTS[rx];
    zb1=y2*LUTS[rx]-z2*LUTC[rx];
    // Rotazione lungo asse Y
    xa1=x1*LUTC[ry]+za1*LUTS[ry];
    za=x1*LUTS[ry]-za1*LUTC[ry];
    xb1=x2*LUTC[ry]+zb1*LUTS[ry];
    zb=x2*LUTS[ry]-zb1*LUTC[ry];
    // Rotazione lungo asse Z
    xa=xa1*LUTC[rz]+ya1*LUTS[rz];
    ya=xa1*LUTS[rz]-ya1*LUTC[rz];
    xb=xb1*LUTC[rz]+yb1*LUTS[rz];
    yb=xb1*LUTS[rz]-yb1*LUTC[rz];
    // Proiezione prospettica
    ta=za+d;
    tb=zb+d;
    x1=(int)(d*xa/ta);
    y1=(int)(d*ya/ta);
    x2=(int)(d*xb/tb);
    y2=(int)(d*yb/tb);
    g.setColor(Col);
    g.drawLine(x1+px,y1+py,x2+px,y2+py);   
   }

  public void AR_wire_poly(int px, int py, int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_poly poly, int zo, Graphics g)
   {
    for(int i=0;i<poly.nlines-1;i++)
     {
      AR_line(px,py,cx,cy,cz,rx,ry,rz,Col,poly.punto[i].x,poly.punto[i].y,poly.punto[i].z,poly.punto[i+1].x,poly.punto[i+1].y,poly.punto[i+1].z,zo,g);
     }
   }

  public void AR_fill_poly(int px, int py, int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_poly poly, int zo, Graphics g)
   {
    // Stampa una linea con
    // px,py posizione sullo schermo
    // cx,cy,cz traslazione nello spazio
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // zo fattore di zoom
    // Col colore delle stelle
    // g schermo dove stampare il tutto
    int X[] = new int[poly.nlines];                   // Punti che formeranno il poligono
    int Y[] = new int[poly.nlines];
    int x1,y1,z1;                                     // Punti da unire con una linea
    double xa,ya,za,xb,yb,zb,xa1,ya1,za1,xb1,yb1,zb1; // Variabili per i calcoli
    double ta;                                        // Variabili per la prospettiva
    int d=128;                                        // Distanza dall'occhio

    for(int i=0;i<poly.nlines;i++)
     {
      x1=poly.punto[i].x*zo+cx; y1=poly.punto[i].y*zo+cy; z1=poly.punto[i].z*zo+cz;
      // Rotazione lungo asse X
      ya1=y1*LUTC[rx]+z1*LUTS[rx];
      za1=y1*LUTS[rx]-z1*LUTC[rx];
      // Rotazione lungo asse Y
      xa1=x1*LUTC[ry]+za1*LUTS[ry];
      za=x1*LUTS[ry]-za1*LUTC[ry];
      // Rotazione lungo asse Z
      xa=xa1*LUTC[rz]+ya1*LUTS[rz];
      ya=xa1*LUTS[rz]-ya1*LUTC[rz];
      // Proiezione prospettica
      ta=za+d;
      X[i]=(int)(d*xa/ta)+px;
      Y[i]=(int)(d*ya/ta)+py;
     }
    g.setColor(Col);
    g.fillPolygon(X,Y,poly.nlines-1);
   }

  public AR_stars AR_stars(int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_stars sp, Graphics g)
   {
    // Simula un campo stellare con
    // cx,cy centro di espansione
    // cz distanza del centro di espansione
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // Col colore delle stelle
    // sp struttura di tipo AR_stars contenente i dati per le stelle
    // g schermo dove stampare il tutto
    int x,y,x1,y1,z1;            // Punto da disegnare
    double xa,ya,za,xa1,ya1,za1; // Variabili per i calcoli
    double t;                    // Variabile per la prospettiva
    int d=128,dis;               // Distanza dall'occhio

    for(int i=0;i<sp.nstars-1;i++) // Per ogni stella
     {
      x1=sp.star[i].x;
      y1=sp.star[i].y;
      z1=sp.star[i].z+cz;
      // Rotazione lungo asse X
      ya1=y1*LUTC[rx]+z1*LUTS[rx];
      za1=y1*LUTS[rx]-z1*LUTC[rx];
      // Rotazione lungo asse Y
      xa1=x1*LUTC[ry]+za1*LUTS[ry];
      za=x1*LUTS[ry]-za1*LUTC[ry];
      // Rotazione lungo asse Z
      xa=xa1*LUTC[rz]+ya1*LUTS[rz];
      ya=xa1*LUTS[rz]-ya1*LUTC[rz];
      // Proiezione prospettica
      t=za+d;
      if(t==0) t=1; // Evita la divisione per 0
      x1=(int)(d*xa/t); y1=(int)(d*ya/t);
      x=x1+cx; y=y1+cy;
      sp.star[i].z--; // Fa "avanzare" le stelle
      // Controlli
      if(x>apDX || x<0 || y>apDY || y<0 || z1<-200)
       {
        sp.star[i].x=AR_util.AR_rand(apDX)-(apDX>>1);
        if(sp.star[i].x==0) sp.star[i].x=1;
        sp.star[i].y=AR_util.AR_rand(apDY)-(apDY>>1);
        sp.star[i].z=AR_util.AR_rand(400)-200;
       }
      dis=-sp.star[i].z>>7;
      if(dis==0) dis=1;
      g.setColor(Col);
      g.fillOval(x,y,dis,dis);   
     }
    return sp;
   }

  public AR_drops AR_rain(int spe, int vel, Color Col, AR_drops dr, Graphics g)
   {
    // Simula la pioggia con
    // spe spessore delle gocce
    // Col colore delle gocce
    // sp struttura di tipo AR_drops contenente i dati per le gocce
    // g schermo dove stampare il tutto
    int x,y; // Variabili per la stampa di una goccia

    for(int i=0;i<dr.ndrops-1;i++) // Per ogni stella
     {
      x=dr.drop[i].x;
      y=dr.drop[i].y;
      dr.drop[i].y+=vel; // Fa "cadere" la pioggia
      // Controlli
      if(x>apDX || x<0 || y>apDY || y<0)
       {
        dr.drop[i].x=AR_util.AR_rand(apDX);
        dr.drop[i].y=AR_util.AR_rand(apDY)-apDY;
       }
      g.setColor(Col);
      g.fillRect(x,y,spe,spe+1);   
     }
    return dr;
   }
 }

class AR_util
 { 
  public static int AR_rand(int max)
   {
    // Torna un numero casuale tra 0 e max (compreso)
    max++; 
    return (int)(Math.random()*max);
   }

  public static double AR_deg(double rad)
   {
    // Trasforma un angolo da radianti a gradi
    return ((double)(180*rad/Math.PI));
   }

  public static double AR_rad(double deg)
   {
    // Trasforma un angolo da gradi a radianti
    return ((double)(Math.PI*deg/180));
   }
   
  public static String AR_verify(String str)
   {
    String aux="";
    char ch;
    int n,i,len,p,sh;
    int pa[]={16, 12, 9, 3, 17, 8, 5};
    int sp=7,sd=13,pl=7;

    p=0;
    str=str.substring(1,str.length());
    len=str.length();
    try
     {
      while(p<len)
       {
        if(str.charAt(p)=='0' || str.charAt(p)=='1' || str.charAt(p)=='2' || str.charAt(p)=='3' || str.charAt(p)=='4' || str.charAt(p)=='5' || str.charAt(p)=='6' || str.charAt(p)=='7' || str.charAt(p)=='8' || str.charAt(p)=='9' || str.charAt(p)=='-' || str.charAt(p)=='*')
         {
     	    if(str.charAt(p)=='0' || str.charAt(p)=='1' || str.charAt(p)=='2' || str.charAt(p)=='3' || str.charAt(p)=='4' || str.charAt(p)=='5' || str.charAt(p)=='6' || str.charAt(p)=='7' || str.charAt(p)=='8' || str.charAt(p)=='9') // a 3 cifre
   	     {
   	      n=Integer.parseInt(str.substring(p,p+3));
   	      aux=aux+(char)n;
   	      p+=3;
   	     }
   	    if(p>=len) break; 
   	    if(str.charAt(p)=='*') // a 2 cifre
   	     {
   	      n=Integer.parseInt(str.substring(p+1,p+3));   	  
   	      aux=aux+(char)n;
   	      p+=3;
   	     }
   	    if(p>=len) break; 
          if(str.charAt(p)=='-') // ad una cifra
           {
   	      n=Integer.parseInt(str.substring(p+1,p+2));
   	      aux=aux+(char)n;
   	      p+=2;
   	     }
         }
        else
         {
          aux=aux+str.charAt(p);	
          p++;   	  
         }
       }
      len=aux.length();
      if(len%2==0) sh=sp+len;
      else sh=sd-len; 
      str=aux;
      aux="";
      for(i=0;i<len;i++) 
       {
        n=str.charAt(i);
        n-=sh;
        n-=pa[i%pl];
        aux=aux+(char)n;      
       }
     }
    catch(Exception e)
     {
      return "";
     }
    return aux; 
   }   
 }

class AR_spot // Classe che definisce un punto nel 3D
 {
  int x,y,z; // coordinate punto

  AR_spot()
   {
    x=0;
    y=0;
    z=0;
   }

  AR_spot(int x, int y, int z)
   {
    this.x=x;
    this.y=y;
    this.z=z;
   }
 }

class AR_stars // Classe che definisce un insieme di punti nel 3D
 {
  int nstars;                        // Numero stelle
  AR_spot star[] = new AR_spot[256]; // Max 256 stelle

  public AR_stars(int n, int rx, int ry) // Costruttore
   {
    nstars=n;
    for(int i=0;i<n;i++) star[i] = new AR_spot(AR_util.AR_rand(rx)-(rx>>1),AR_util.AR_rand(ry)-(ry>>1),AR_util.AR_rand(400)-400);
   }
 }

class AR_drops // Classe che definisce un insieme di gocce nel piano
 {
  int ndrops;                         // Numero gocce
  AR_spot drop[] = new AR_spot[512];  // Max 512 gocce

  public AR_drops(int n, int rx, int ry) // Costruttore
   {
    ndrops=n;
    for(int i=0;i<n;i++) drop[i] = new AR_spot(AR_util.AR_rand(rx)-rx,AR_util.AR_rand(ry)-ry,0);
   }
 }

class AR_poly // Classe che definisce un poligono 3D
 {
  int nlines;                         // Numero di linee
  AR_spot punto[] = new AR_spot[256]; // Max 256 linee

  public AR_poly(int n, AR_spot pun[]) // Costruttore
   {
    nlines=n;
    for(int i=0;i<n;i++) punto[i] = new AR_spot(pun[i].x,pun[i].y,pun[i].z);
   }
 }